/*

 chanopn_c

 Open a channel with specified owner, returns -1 if error, else 0.
 Sets _oserr and errno

 Date		Author		Comments
 ----		------		--------
 02/09/1991	P.J. Taylor	Original.
 10/10/1991	P.J. Taylor	Amended.

 1.04
 ----
 07/03/1998	A.D.Ives	Source code reformatted.

*/

#include <sys/types.h>
#include <errno.h>
#include <qdos.h>
#include <debug.h>
#include <string.h>

int chanopn(chanid_t *chan, char *name, jobid_t owner, long otype) {

  /* chan	Set to channel opened					*/
  /* name	Filename						*/
  /* owner	Job to own opened channel				*/
  /* otype	Channel ID of opposite end of pipe or Open Type 	*/

  struct REGS
       ri ,	/* Input to QDOS Trap		*/
       ro ;	/* Output from QDOS Trap	*/
  union {
    struct QLSTR name ; 	/* Filename as QL string	*/
    char area[MAXNAMELEN + 2] ; /* Defines size of Union	*/
  } qs ;

  errno= 0 ;
  _oserr= 0 ;
  if ( strlen(name) > MAXNAMELEN ) {    /* Too big for qs       */
    errno= EOSERR ;
    _oserr= ERR_BN ;
  }

  if ( !_oserr ) {
    ri.D0= (datareg_t) (1) ;
    ri.D1= (datareg_t) owner ;
    ri.D3= (datareg_t) otype ;
    ri.A0= (addreg_t) cstr_to_ql(&qs.name, name) ;

    qdos2(&ri, &ro) ;

    if ( ro.D0 < 0 ) {
      errno= EOSERR ;
      _oserr= (long) ro.D0 ;
    }
    else
      *chan= (chanid_t) ro.A0 ;
  }

  if ( errno )
    return -1 ;
  else
    return 0 ;
}
