#ifndef PJTLIB_H
#define PJTLIB_H
/*

 pjtlib_h

 Shell Support Library

 Date           Author          Comments
 ----           ------          --------
 25/08/1991     P.J.Taylor      Created.
 23/09/1991     P.J.Taylor      Amended.

 1.05
 ----
 09/03/1998     A.D.Ives        New module misc_c added.

 1.06
 ----
 10/03/1998     A.D.Ives        RootDir(), DirChange(), UpDir() and SetOSDir()
                                and directory identifier constants moved here
                                from shint_c.
                                FindFile() moved here from jobload_c.
                                Prototypes added for ...
                                DirNav(), NavName(), SlashToBackslash(),
                                Date(), Time().
 11/03/1998                     Prototypes added for ...
                                MediumInfo(), strrstr()
 12/03/1998                     Prototypes added for ...
                                SetCon(), MoveCon()

 1.07
 ----
 15/03/1998                     Mis-spelling of RootDir() prototype fixed.

*/
#define TRUE 1
#define FALSE 0

#ifndef _ANSI_H
#include <ansicondef.h>
#endif

#ifndef _TYPES_H
#include <sys/types.h>
#endif

/* Directory Identifier for SetOSDir() */

#define D_DATAD 0
#define D_PROGD 1
#define D_DESTD 2

extern char *qdos_errlist[] ;  /* QDOS error messages */
extern int qdos_nerr ;         /* number of messages defined */

void qerror(char *) ;
void qerror2(char * , char *) ;
jobid_t jobload(char * , char * , jobid_t) ;
int jobchan(jobid_t , chanid_t) ;
int jobpipe(jobid_t , jobid_t) ;
int jobstrt(jobid_t , int , long * ) ;
int jobterm(jobid_t) ;
int chanopn(chanid_t * , char * , jobid_t , long) ;
int io_open3 (char *, int, int) ;

int fi2exec(char * fnam, chanid_t chanid) ;
int ShellOpt(char *) ;
int IsNewC68(char *) ;
char *UpDir(char *) ;
char *RootDir(char *) ;
char *DirChange(char *, char *) ;
void SetOSDir(int) ;
char *DirNav(char *, char *, char *, char *) ;
char *NavName(char *) ;
void FindFile(chanid_t *, char *, char *, char *, char *, char *) ;
char *SlashToBackslash(char *) ;
char *strrstr(const char *, const char *) ;
char *Date(char *) ;
char *Time(char *) ;
int MediumInfo(unsigned long *, unsigned long *, unsigned long *, char *) ;
void SetCon(chanid_t, char *) ;
void MoveCon(chanid_t) ;

#endif
